 ###############################################
#                                               #
#              I R C   S T O R Y                #
#       v1.02 (08/06/2009) par MenzAgitat       #
#                                               #
#          http://www.boulets-roxx.com          #
#        IRC:  irc.epiknet.org  #boulets        #
#              irc.teepi.net    #boulets        #
#                                               #
#     Mes scripts sont tlchargeables sur      #
#            http://www.eggdrop.fr              #
#        ou  http://www.egghelp.org             #
#                                               #
 ###############################################

#
# Syntaxe : !story [nick1] [nick2] [nick3] [nick4] [nick5] [nick6] [nick7]
#
# Description :
# Utilise sans arguments, la commande !story gnre un scnario alatoire entre
# 1  7 personnes parmi les utilisateurs connects sur le chan.
# Vous pouvez aussi spcifier de 1  7 noms pour choisir les intervenants du
# scnario.
#
# La commande !story.stats permet d'afficher le nombre de fragments de phrase
# disponibles pour chaque type (voir explications plus bas)
#
# Vous pouvez aisment ajouter vos propres fragments de phrase en faisant
# toutefois attention  les placer dans la bonne catgorie.
#
# Table de rfrence des diffrents modles de phrase disponibles :
###### MODELE 1 (1 user) :
#		/me [frag_type 1] $user [frag_type 4]
#		---> /me fait quoi  untel de quelle faon
#		ou
#		/me [frag_type 1] $user [frag_type 11]
# 	---> /me fait quoi  untel o/comment
#		ou
#		$user [frag_type 2].
# 	---> untel fait quoi.
#		ou
#		$user [frag_type 9].
# 	---> untel fait quoi.
###### MODELE 2 (2 users) :
#		$user [frag_type 1] $user [frag_type 4].
#		---> untel fait quoi  untel de quelle faon.
#		ou
#		$user [frag_type 1] $user [frag_type 11].
#		---> untel fait quoi  untel o/comment.
#		ou
#		$user [frag_type 1] $user.
#		---> untel fait quoi  untel.
###### MODELE 3 (3 users) :
#		$user [frag_type 1] $user [frag_type 4] [frag_type 3] $user.
#		---> untel fait quoi  untel de quelle faon o/comment avec untel.
#		ou
#		$user [frag_type 1] $user [frag_type 3] $user.
#		---> untel fait quoi  untel o/comment avec untel.
#		ou
#		$user [frag_type 1] $user, [frag_type 7] $user [frag_type 2].
#		---> untel fait quoi  untel, *enchanement* untel fait quoi.
#		ou
#		$user [frag_type 1] $user, [frag_type 7] $user [frag_type 9].
#		---> untel fait quoi  untel, *enchanement* untel fait quoi(2).
###### MODELE 4 (4 users) :
#		$user [frag_type 1] $user [frag_type 3] $user, [frag_type 7] $user [frag_type 2] [frag_type 4].
#		---> untel fait quoi  untel o/comment avec untel, *enchanement* untel fait quoi de quelle faon.
#		ou
#		$user [frag_type 1] $user [frag_type 3] $user, [frag_type 7] $user [frag_type 2] [frag_type 11].
#		---> untel fait quoi  untel o/comment avec untel, *enchanement* untel fait quoi o/comment.
#		ou
#		$user [frag_type 1] $user [frag_type 3] $user, [frag_type 7] $user [frag_type 2].
#		---> untel fait quoi  untel o/comment avec untel, *enchanement* untel fait quoi.
#		ou
#		$user [frag_type 1] $user [frag_type 3] $user, [frag_type 7] $user [frag_type 9].
#		---> untel fait quoi  untel o/comment avec untel, *enchanement* untel fait quoi(2).
###### MODELE 5 (5 users) :
#		$user [frag_type 1] $user [frag_type 3] $user, [frag_type 7] $user [frag_type 2] [frag_type 5] $user.
#		---> untel fait quoi  untel o/comment avec untel, *enchanement* untel fait quoi avec quoi de untel.
###### MODELE 6 (6 users) :
#		$user [frag_type 1] $user [frag_type 3] $user, [frag_type 7] $user [frag_type 2] [frag_type 4] [frag_type 6] $user. [frag_type 8] $user [frag_type 9].
#		---> untel fait quoi  untel o/comment avec untel, *enchanement* untel fait quoi de quelle faon en faisant quoi  untel. *enchanement2* untel fait quoi.
###### MODELE 7 (7 users) :
#		$user [frag_type 1] $user [frag_type 3] $user, [frag_type 7] $user [frag_type 2] [frag_type 4]. [frag_type 10] $user [frag_type 1] $user. [frag_type 8] $user [frag_type 9].
#		---> untel fait quoi  untel o/comment avec untel, *enchanement* untel fait quoi de quelle faon. *transition* untel fait quoi  untel. *enchanement2* untel fait quoi.
#
# Types de fragments de phrase :
# Type 1	: fait quoi  untel
# Type 2	: fait quoi
# Type 3	: o/comment avec untel
# Type 4	: de quelle faon / avec quoi
# Type 5	: avec quoi de untel
# Type 6	: en faisant quoi  untel
# Type 7	: enchanement
# Type 8	: enchanement 2
# Type 9	: fait quoi (2)
# Type 10	: transition
# Type 11	: o/comment
#

#
#	Changelog
#		1.0 	- 1re version
#		1.01	- correction prise en charge des caractres spciaux dans les nicks
#					- correction du paramtre allowed_chans qui n'tait pas pris en compte
#					- le bot n'enregistre plus automatiquement un nouveau chan si un chan
#						dfini dans allowed_chans n'existe pas; il le signale seulement en
#						partyline et dans ses logs.
#		1.02	- ajout de 7 nouveaux modles de phrase ainsi que de nouveaux
#						fragments.
#

#
# LICENCE:
#		This program is free software; you can redistribute it and/or modify
#		it under the terms of the GNU General Public License as published by
#		the Free Software Foundation; either version 2 of the License, or
#		(at your option) any later version.
#
#		This program is distributed in the hope that it will be useful,
#		but WITHOUT ANY WARRANTY; without even the implied warranty of
#		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#		GNU General Public License for more details.
#

if { [lindex [split $version] 1] < 1061800 } { putloglev o * "\00304\002\[IRC Story - ERREUR\]\002\003 La version de votre eggdrop est \00304\002[lindex [split $version] 0]\002\003; IRC-Story.tcl ne fonctionnera correctement que sur les eggdrops version 1.6.18 ou suprieure." ; return }
if { $tcl_version < 8.4 } { putloglev o * "\00304\002\[IRC Story - ERREUR\]\002\003 IRC-Story.tcl ncessite que Tcl 8.4 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.4
if {[info commands IRCSTORY::uninstall] eq "::IRCSTORY::uninstall"} { IRCSTORY::uninstall }
namespace eval IRCSTORY {


	###########################
	#				PARAMETRES        #
	###########################

	# Chans sur lesquels le script sera actif (spars par un espace)
	# Attention aux majuscules, le nom du chan est sensible  la casse.
	# Si le nom du chan contient le caractre } ou { , vous devez le remplacer
	# par \} ou \{. exemple : si votre chan s'appelle #mon{chan},
	#	mettez #mon\{chan\}.
  variable allowed_chans {#chan1 #chan2 #chan3}

	#### COMMANDES ET AUTORISATIONS
  #
	# Commande utilise pour afficher un scnario
	# ex. : "!story"
	variable storycmd "!story"
	# autorisations pour la commande utilise pour afficher un scnario
	variable storyauth "-|-"

	#### PARAMETRES DE L'ANTI-FLOOD
  #
  # Anti-flood (0 = dsactiv, 1 = activ)
  variable antiflood 1
  # Combien de commandes sont autorises en combien de temps ?
  # exemple : "6:30" = 6 commandes maximum en 30 secondes;
  # les suivantes seront ignores.
  variable cmdflood_story "3:180"
  # Intervalle de temps minimum entre l'affichage de 2 messages
  # avertissant que l'anti-flood a t dclench (ne rglez pas
  # cette valeur trop bas afin de ne pas tre flood par les messages
  # d'avertissement de l'anti-flood...)
  variable antiflood_msg_interval 30

	##################### FRAGMENTS DE PHRASES #####################
	# Voici des morceaux de phrase qui seront combins alatoirement pour
	# construire les scenarii.
	# Si vous en ajoutez, mettez-les dans la bonne catgorie, ils sont classs
	# par type.
	#
	# TYPE 1	-------------------------- 	fait quoi  untel
	variable type1_fragment {
		{applaudit}
		{arrache les cheveux de}
		{arrache les vtements de}
		{assomme}
		{attache ensemble les lacets des chaussures de}
		{brle la chaise de}
		{chatouille}
		{crache dans le yop de}
		{demande un autographe }
		{drague}
		{dclare sa flamme }
		{dcoiffe}
		{dfie}
		{dshabille}
		{clate de rire  la vue de}
		{crase le pied de}
		{effleure le sein de}
		{embrasse follement}
		{met des gargouillements  l'attention de}
		{engueule}
		{envoie un regard coquin }
		{espre se faire remarquer par}
		{ternue  la figure de}
    {excute un pas de danse avec}
		{fait couiner le nez de}
		{fait la danse du ventre }
		{fait tomber}
		{fait un croche-pied }
		{fait un strip-tease }
		{fait une grimace }
		{gifle}
		{gratouille}
		{imite}
		{implore la piti de}
		{jette des pluchures de pommes de terre sur}
		{jette un seau d'eau sur}
		{joue  la marelle avec}
		{joue  saute-mouton avec}
		{lance des cacahutes }
		{ligote}
		{lche les orteils de}
		{lche les sourcils de}
		{lchouille}
		{met le feu aux cheveux de}
		{met un coup de pied au cul de}
		{met un doigt dans l'oeil de}
		{mord l'oeil de}
		{mordille l'oreille de}
		{plie en deux}
		{pointe un lance-pure vers}
		{porte plainte contre}
		{pousse}
		{prend la main de}
		{prpare une mauvaise blague }
		{se dfonce  la colle avec}
		{se fait des films sur}
		{se fche tout rouge aprs}
		{se jette sous les roues de}
		{se moque de}
		{se pochtronne avec}
		{se roule sur}
		{siffle}
		{tape}
		{tire la langue }
		{tombe sur}
		{vide la corbeille  papiers sur}
		{vide un pot de peinture sur}
		{s'excite sur la jambe de}
		{se frotte sur la jambe de}
		{se prosterne devant}
		{dnoyaute}
		{pluche}
	}
	# TYPE 2	-------------------------- 	fait quoi ?
	variable type2_fragment {
		{mange une saucisse}
		{met son slip sur sa tte}
		{lui gratouille la tte}
		{n'en croit pas ses yeux}
		{regarde ailleurs}
		{se roule par terre}
		{examine ses crottes de nez}
		{regarde effar}
		{cherche le responsable de ce merdier}
		{lui met un vent}
		{ricane bizarrement}
		{se marre de manire incontrlable}
		{clate de rire}
		{s'enfuit en courant}
		{part en courant}
		{court se cacher}
		{le menace avec une petite cuiller}
		{se prend pour Dieu}
		{s'indigne qu'on laisse faire des choses pareilles}
		{se fait profondment chier}
		{se frotte les mains}
		{se tartine de mayonnaise}
		{se badigeonne de nutella}
		{se barbouille de confiture}
		{se laisse pousser la barbe}
		{se met un doigt dans le nez}
		{se jette du haut d'un tabouret}
		{se gratte le dos}
		{lui tire la langue}
		{se moque de lui}
		{se mouche dedans}
		{ternue}
		{siflotte nonchalamment}
		{se soulage dans un coin}
		{examine le plafond}
		{s'endort sur sa chaise}
		{s'asperge de parfum}
		{se prend les pieds dans le fil}
		{tombe dans l'escalier}
		{se roule dans la boue}
		{se tape la tte contre le mur}
		{effectue un pas de danse}
		{croit tre dans un dessin anim}
		{se renifle les doigts}
		{s'enduit de goudron}
		{se tricote un pull}
		{se prend pour le matre du monde}
		{se casse la gueule}
		{s'pile les jambes}
		{danse un pogo}
		{raconte une histoire drle}
		{s'enfonce des smarties dans le nez}
		{lui tend une corde}
		{se prend pour le matre du monde}
		{pisse partout}
		{enfile sa camisole}		
		{fouille dans son nez}
		{essaie de trouver un truc intelligent  dire}
		{tlphone aux urgences}
		{le regarde avec la bouche en coeur}
		{cherche quelque chose dans son slip}
		{cherche la sortie}
		{appelle des renforts}
		{se gratte le nez}
		{se recoiffe}
		{lui pince les fesses}
		{dcide de faire la cuisine}
		{crit une lettre au Pre Nol}
		{gesticule dans tous les sens}
		{sautille partout}
		{se met  poil}
		{se gratte les couilles}
	}
	# TYPE 3	-------------------------- 	o/comment avec untel
	variable type3_fragment {
		{dans les rves de}
		{dans une ruelle sombre avec}
		{dans la 4me dimension avec}
		{dans les vestiaires avec}
		{ quatre pattes avec}
		{dans l'imagination de}
		{tout nu avec}
		{sous la douche avec}
		{dans un show tlvis avec}
		{dans une discothque avec}
		{dans une dcharge publique avec}
		{dans les cheveux de}
		{sur le dos de}
		{sur les genoux de}
		{sur les paules de}
		{dans le frigo de}
		{dans l'vier de}
		{sous le bureau de}
		{sous la table de}
		{dans le placard de}
		{dans le fauteuil de}
		{dans le pantalon de}
		{sous les draps de}
		{dans le lit de}
		{dans la salle de bains de}
		{dans les bras de}
		{dans le grenier de}
		{dans la cave de}
		{dans la chambre de}
		{dans un film X avec}
		{sur une le dserte avec}
		{ pieds joints sur}
		{en sautillant avec}
		{devant la webcam de}
		{dans un jacuzzi avec}
		{dans un hammam avec}
		{dans un bled paum avec}
		{au milieu de l'autoroute avec}
		{dans des toilettes publiques avec}
		{dans les toilettes avec}
		{en quilibre sur la cuvette des toilettes avec}
		{dans un mtro bond avec}
		{sur le trottoir avec}
	}
	# TYPE 4	-------------------------- 	de quelle faon / avec quoi
	variable type4_fragment {
		{avec beaucoup de prcautions}
		{aimablement}
		{plein de bonnes intentions} 
		{avec humour}
		{avec du talc}
		{avec une fourchette}
		{avec fermet}
		{avec ardeur}
		{avec un dmonte-pneu}
		{avec des cornichons}
		{avec une pelle  neige}
		{avec des bretelles}
		{avec une roue de vlo}
		{avec 2 ou 3 olives}
		{avec du guano}
		{avec beaucoup de difficults}
		{avec l'aide de l'arme}
		{avec du cirage noir}
		{avec un chausse-pied}
		{avec une batte de baseball}
		{avec un tournevis}
		{avec du fard  paupires}
		{avec de la sauce pimente}
		{avec un moule  gauffres}
		{avec une tartine beurre}
		{avec enthousiasme}
		{avec son air innocent}
		{avec une pelleteuse}
		{avec une petite cuiller}
		{avec un parachute}
		{avec ses doigts}
		{avec une pince  piler}
		{avec une grue de chantier}
	}
	# TYPE 5	-------------------------- 	avec quoi de untel
	variable type5_fragment {
		{avec la scie de}
		{sans le consentement de}
		{avec les pieds de}
		{avec le clavier de}
		{avec le petit doigt de}
		{avec l'aide de}
		{avec la participation de}
		{avec la complicit de}
		{avec la carte bleue de}
		{avec les lunettes de}
		{avec les chaussettes de}
		{avec le vlo de}
		{avec les chaussettes de}
		{avec l'approbation de}
		{avec la souris de}
		{avec le shampooing de}
		{avec la permission de}
		{avec le partenariat officiel de}
		{avec le fond du pantalon de}
		{avec les cheveux de}
		{avec la casquette de}
		{avec l'encouragement de}
		{avec les doigts de}
	}
	# TYPE 6	-------------------------- 	en faisant quoi  untel
	variable type6_fragment {
		{en applaudissant}
		{en arrachant les cheveux de}
		{en arrachant les vtements de}
		{en assommant}
		{en attachant ensemble les lacets des chaussures de}
		{en brlant la chaise de}
		{en chatouillant}
		{en crachant dans le yop de}
		{en demandant un autographe }
		{en draguant}
		{en dclarant sa flamme }
		{en dcoiffant}
		{en dfiant}
		{en dshabillant}
		{en effleurant le sein de}
		{en embrassant follement}
		{en engueulant}
		{en envoyant un regard coquin }
		{en esprant se faire remarquer par}
		{en faisant couiner le nez de}
		{en faisant tomber}
		{en faisant un croche-pied }
		{en faisant un strip-tease }
		{en faisant une grimace }
		{en giflant}
		{en gratouillant}
		{en imitant}
		{en implorant la piti de}
		{en jetant des pluchures de pommes de terre sur}
		{en jetant un seau d'eau sur}
		{en jouant  la marelle avec}
		{en jouant  saute-mouton avec}
		{en lanant des cacahutes }
		{en ligotant}
		{en lchant les orteils de}
		{en lchant les sourcils de}
		{en lchouillant}
		{en mettant le feu aux cheveux de}
		{en mettant un coup de pied au cul de}
		{en mettant un doigt dans l'oeil de}
		{en mordant l'oeil de}
		{en mordillant l'oreille de}
		{en pliant en deux}
		{en pointant un lance-pure vers}
		{en poussant}
		{en prenant la main de}
		{en prparant une mauvaise blague }
		{en se dfonant  la colle avec}
		{en se faisant des films sur}
		{en se fchant tout rouge aprs}
		{en se jetant sous les roues de}
		{en se moquant de}
		{en se pochtronnant avec}
		{en se roulant sur}
		{en sifflant}
		{en tapant}
		{en tirant la langue }
		{en tombant sur}
		{en vidant la corbeille  papiers sur}
		{en vidant un pot de peinture sur}
		{en clatant de rire  la vue de}
		{en crasant le pied de}
		{en mettant des gargouillements  l'attention de}
		{en ternuant  la figure de}
    {en excutant un pas de danse avec}
		{en s'excitant sur la jambe de}
		{en se frottant sur la jambe de}
	}
	# TYPE 7	-------------------------- 	enchanement
	variable type7_fragment {
		{pendant que}
		{pendant que}
		{pendant que}
		{alors que}
		{alors que}
		{alors que}
		{tandis que}
		{tandis que}
		{tandis que}
		{sans compter que}
		{sans compter que}
		{en imaginant que}
		{en imaginant que}
		{sans se douter que}
	}
	# TYPE 8	-------------------------- 	enchanement (2)
	variable type8_fragment {
		{On peut observer que}
		{Vu comme c'est parti,}
		{Je crois que}
		{On dirait que}
		{Visiblement,}
		{Manifestement,}
		{C'est drle parce que}
		{C'est marrant parce que}
		{C'est bizarre parce que}
		{C'est trange parce que}
		{C'est fou,}
		{Bizarrement,}
		{Etrangement,}
		{Etonnamment,}
		{Tout laisse penser que}
		{On serait tent de croire que}
	}
	# TYPE 9	-------------------------- 	fait quoi (2)
	variable type9_fragment {
		{s'enfuit  toutes jambes}
		{saute  cloche-pied sans raison apparente}
		{espre que tout ce bordel va enfin cesser}
		{se demande pourquoi il fait a}
		{a cru bien faire}
		{a vraiment eu une ide -la-con}
		{a merd}
		{a encore merd}
		{a encore jou avec les rglages}
		{a des auroles sous les bras}
		{raconte vraiment n'importe quoi}
		{n'aurait pas d se teindre en blonde}
		{se doutait bien que a se terminerait comme a}
		{a d se tromper de fentre}
		{a mis son slip sur sa tte}
		{se met du vernis  ongles maintenant}
		{prend la poudre d'escampette}
		{va tre jaloux}
		{s'en fiche perdment}
		{a mieux  faire que de s'en proccuper}
		{observe la scne attentivement}
		{regarde en l'air comme si de rien n'tait}
		{prend un air innocent}
		{devrait changer de chemise}
		{a une haleine de cheval}
		{est coiff comme un dessous de bras}
		{n'aurait pas d nerver Chuck Norris}
		{s'enfuit en courant}
		{se met  danser la salsa}
		{a l'air petit quand il se met debout}
		{a les bras qui touchent par terre}
		{a teint ses cheveux en mauve}
		{court se cacher}
		{prend un air tonn}
		{s'en fout compltement}
		{aimerait bien tre ailleurs}
		{commence  transpirer  grosses gouttes}
		{a l'air gn}
		{espre que a va attirer l'attention}
		{espre que personne n'aura remarqu}
		{s'essuie avec}
		{prend une photo de la scne}
		{s'habille vraiment comme un sac}
		{a mis son pantalon  l'envers}
		{a l'air un peu perdu}
		{observe la scne en prenant des notes}
		{fait comme s'il n'avait rien remarqu}
		{a l'air dsempar}
		{trouve qu'il se passe des choses bizarres}
		{se demande pourquoi il est tout nu}
		{filme la scne}
		{s'en fout pas mal}
		{s'en moque compltement}
		{se demande ce qu'il fait l}
		{vient de s'apercevoir qu'il s'est coinc un truc dans l'oreille}
		{se cherche des excuses}
		{s'est enduit de goudron et regarde les plumes avec un vif intrt}
		{baille}
		{prend des poses de mannequin}
		{a du mal  comprendre ce qu'il se passe}
		{se demande pourquoi il n'a plus qu'un seul sourcil}
		{se demande pourquoi il a mis du vernis  ongles}
		{se demande pourquoi des plumes dpassent de son short}
		{doit halluciner}
		{peut s'estimer chanceux}
	}
	# TYPE 10	 ------------------------- 	transition
	variable type10_fragment {
		{Pendant ce temps,  Vera Cruz}
		{Quand il s'aperoit de a}
		{Quand il se rend compte de a}
		{En voyant a}
		{Aprs avoir analys la situation}
		{Croyant bien faire}
		{Aprs en avoir dduit qu'il ne pourrait pas faire pire}
		{Se demandant si il pourrait faire un truc encore plus dlire}
		{Essayant de se concentrer malgr tout ce bordel}
		{Mettant un soin tout particulier  ne pas faire mieux que les autres}
		{Histoire de faire comme tout le monde}
		{Aprs un court instant de rflexion}
	}
	# TYPE 11	-------------------------- 	o/comment
	variable type11_fragment {
		{dans ses rves}
		{dans une ruelle sombre}
		{dans la 4me dimension}
		{dans les vestiaires}
		{ quatre pattes}
		{dans son imagination}
		{tout nu}
		{sous la douche}
		{dans un show tlvis}
		{dans une discothque}
		{dans une dcharge publique}
		{dans son frigo}
		{dans son vier}
		{sous le bureau}
		{sous la table}
		{dans le placard}
		{dans son fauteuil}
		{dans son pantalon}
		{sous ses draps}
		{dans son lit}
		{dans sa salle de bains}
		{dans son grenier}
		{dans sa cave}
		{dans sa chambre}
		{dans un film X}
		{sur une le dserte}
		{en sautillant}
		{devant sa webcam}
		{dans un jacuzzi}
		{dans un hammam}
		{dans un bled paum}
		{au milieu de l'autoroute}
		{dans des toilettes publiques}
		{dans ses toilettes}
		{en quilibre sur la cuvette des toilettes}
		{dans un mtro bond}
		{sur le trottoir}
	}



####################################################################
#                                                                  #
# NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE CONNAISSEZ PAS LE TCL #
#                                                                  #
#   DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL    #
#                                                                  #
####################################################################

	variable scriptname "IRC Story"
  variable version "1.02.20090608"
	variable DEBUGMODE 0
	# inutilis, conserv au cas o
	variable cmdflood_global "5:120"
	variable floodsettingsstring [split "global $cmdflood_global story $cmdflood_story"]
	variable floodsettings ; array set floodsettings $floodsettingsstring
	variable instance ; array set instance {}
	variable antiflood_msg ; array set antiflood_msg {}
	bind pub $storyauth $storycmd IRCSTORY::pub_disp_story
	bind pub m|m !story.stats IRCSTORY::story_stats
	bind evnt - prerehash IRCSTORY::uninstall
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$IRCSTORY::scriptname...\002"
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [string range [namespace current] 2 end]]*] " (::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		namespace delete ::IRCSTORY
	}
	# Vrification de la validit des chans dfinis
	foreach element $IRCSTORY::allowed_chans {
		if {(![validchan $element]) && ([lsearch [string tolower [channels]] [string tolower $element]] == -1)} {
			putloglev o * "\00304\002\[IRC Story - WARNING\]\002\003 Le chan \002$element\002 spcifi dans la configuration n'est pas un chan enregistr sur l'eggdrop."
		} 	
	}
}

# Affichage des stats (compte du nombre de fragments de phrase de chaque type)
proc IRCSTORY::story_stats {nick host handle chan arg} {
	if { [lsearch -exact $IRCSTORY::allowed_chans $chan] == -1 } { return }
	puthelp "PRIVMSG $chan :[code underline $chan]Nombre de fragments de phrase de chaque type[code underline $chan] : \
	[code bold $chan]1[code bold $chan] - [code 14 $chan][llength $IRCSTORY::type1_fragment][code endcolor $chan] [code 07 $chan]|[code endcolor $chan] \
	[code bold $chan]2[code bold $chan] - [code 14 $chan][llength $IRCSTORY::type2_fragment][code endcolor $chan] [code 07 $chan]|[code endcolor $chan] \
	[code bold $chan]3[code bold $chan] - [code 14 $chan][llength $IRCSTORY::type3_fragment][code endcolor $chan] [code 07 $chan]|[code endcolor $chan] \
	[code bold $chan]4[code bold $chan] - [code 14 $chan][llength $IRCSTORY::type4_fragment][code endcolor $chan] [code 07 $chan]|[code endcolor $chan] \
	[code bold $chan]5[code bold $chan] - [code 14 $chan][llength $IRCSTORY::type5_fragment][code endcolor $chan] [code 07 $chan]|[code endcolor $chan] \
	[code bold $chan]6[code bold $chan] - [code 14 $chan][llength $IRCSTORY::type6_fragment][code endcolor $chan] [code 07 $chan]|[code endcolor $chan] \
	[code bold $chan]7[code bold $chan] - [code 14 $chan][llength $IRCSTORY::type7_fragment][code endcolor $chan] [code 07 $chan]|[code endcolor $chan] \
	[code bold $chan]8[code bold $chan] - [code 14 $chan][llength $IRCSTORY::type8_fragment][code endcolor $chan] [code 07 $chan]|[code endcolor $chan] \
	[code bold $chan]9[code bold $chan] - [code 14 $chan][llength $IRCSTORY::type9_fragment][code endcolor $chan] [code 07 $chan]|[code endcolor $chan] \
	[code bold $chan]10[code bold $chan] - [code 14 $chan][llength $IRCSTORY::type10_fragment][code endcolor $chan] \
	[code bold $chan]11[code bold $chan] - [code 14 $chan][llength $IRCSTORY::type11_fragment][code endcolor $chan]"
}

# procdure principale
proc IRCSTORY::pub_disp_story {nick host handle chan arg} {
	if { ([lsearch -exact $IRCSTORY::allowed_chans $chan] == -1) || (($IRCSTORY::antiflood == 1) && ([IRCSTORY::antiflood $chan "story"] == "flood")) } { return }
	array set users_selection {}
	set arg [split $arg]
	if {[llength $arg] == 0} {
		set users [chanlist $chan -b|]
		if {[set total_users [llength $users]] >= 7} { set modulo 7 } { set modulo $total_users }
		set num_users [expr [expr [clock clicks -milliseconds] % $modulo] + 1]
	}	else {
		set arg [split [string trim [regsub -all {\ +}  [IRCSTORY::filter [join $arg]] " "]]]
		if {[set num_users [llength $arg]] <= 7} {
			set users [chanlist $chan]
			foreach element $arg {
				if {[lsearch [string tolower $users] [string tolower $element]] == -1} {
					puthelp "PRIVMSG $chan :[code bold $chan][join $element][code bold $chan] [code 14 $chan]n'est pas prsent sur ce chan.[code endcolor $chan]"
					IRCSTORY::antiflood_close_instance $chan "story"
					return
				}
			}
			# on mlange l'ordre des nicks passs en argument de faon alatoire
			set arg [IRCSTORY::randomize_list $arg]
		} else {
			puthelp "PRIVMSG $chan :[code 14 $chan]Les scenarii mettant en scne plus de 7 personnes ne sont actuellement pas supports.[code endcolor $chan]"
			IRCSTORY::antiflood_close_instance $chan "story"
			return
		}
	}
	for { set counter 1 } { $counter <= $num_users } { incr counter } {
		set rand_num [expr [clock clicks -milliseconds] % [llength $users]]
		if {[lindex $arg 0] eq ""} {
			set users_selection($counter) [IRCSTORY::filter [lindex $users $rand_num]]
			set users [lreplace $users $rand_num $rand_num]
		} else {
			set users_selection($counter) [lindex $arg [expr $counter - 1]]
		}
	}
	switch $num_users {
    1 {	set random [expr [clock clicks -milliseconds] % 4]
    		switch $random {
    			0 { set output "\001ACTION [random_fragment 1] $users_selection(1) [random_fragment 4]\001" }
    			1 { set output "\001ACTION [random_fragment 1] $users_selection(1) [random_fragment 11]\001" }
    			2 { set output "$users_selection(1) [random_fragment 2]" }
    			3 { set output "$users_selection(1) [random_fragment 9]" }
    		}
    	}
    2 { set random [expr [clock clicks -milliseconds] % 3]
    		switch $random {
    			0 { set output "$users_selection(1) [random_fragment 1] $users_selection(2) [random_fragment 4]." }
    			1 { set output "$users_selection(1) [random_fragment 1] $users_selection(2) [random_fragment 11]." }
    			1 { set output "$users_selection(1) [random_fragment 1] $users_selection(2)." }
				}    			
    	}
    3 { set random [expr [clock clicks -milliseconds] % 4]
    		switch $random {
    			0 { set output "$users_selection(1) [random_fragment 1] $users_selection(2) [random_fragment 4] [random_fragment 3] $users_selection(3)." }
    			1 { set output "$users_selection(1) [random_fragment 1] $users_selection(2) [random_fragment 3] $users_selection(3)." }
					2 { set output "$users_selection(1) [random_fragment 1] $users_selection(2), [random_fragment 7] $users_selection(3) [random_fragment 2]." }
					3 { set output "$users_selection(1) [random_fragment 1] $users_selection(2), [random_fragment 7] $users_selection(3) [random_fragment 9]." }
    		}
    	}
    4 { set random [expr [clock clicks -milliseconds] % 4]
    		switch $random {
    			0 { set output "$users_selection(1) [random_fragment 1] $users_selection(2) [random_fragment 3] $users_selection(3), [random_fragment 7] $users_selection(4) [random_fragment 2] [random_fragment 4]." }
    			1 { set output "$users_selection(1) [random_fragment 1] $users_selection(2) [random_fragment 3] $users_selection(3), [random_fragment 7] $users_selection(4) [random_fragment 2] [random_fragment 11]." }
    			2 { set output "$users_selection(1) [random_fragment 1] $users_selection(2) [random_fragment 3] $users_selection(3), [random_fragment 7] $users_selection(4) [random_fragment 2]." }
    			3 { set output "$users_selection(1) [random_fragment 1] $users_selection(2) [random_fragment 3] $users_selection(3), [random_fragment 7] $users_selection(4) [random_fragment 9]." }
    		}
    	}
    5 { set output "$users_selection(1) [random_fragment 1] $users_selection(2) [random_fragment 3] $users_selection(3), [random_fragment 7] $users_selection(4) [random_fragment 2] [random_fragment 5] $users_selection(5)." }
    6 { set output "$users_selection(1) [random_fragment 1] $users_selection(2) [random_fragment 3] $users_selection(3), [random_fragment 7] $users_selection(4) [random_fragment 2] [random_fragment 4] [random_fragment 6] $users_selection(5). [random_fragment 8] $users_selection(6) [random_fragment 9]." }
    7 { set output "$users_selection(1) [random_fragment 1] $users_selection(2) [random_fragment 3] $users_selection(3), [random_fragment 7] $users_selection(4) [random_fragment 2] [random_fragment 4]. [random_fragment 10], $users_selection(5) [random_fragment 1] $users_selection(6). [random_fragment 8] $users_selection(7) [random_fragment 9]." }
  }
	if { $IRCSTORY::DEBUGMODE } { putlog "\00304\002\[irc-story debug\]\002\003 \00314num_users :\003 $num_users \00307|\003 \00314array users_selection :\003 [array get users_selection] \00307|\003 \00314raw output :\003 $output" }
	puthelp "PRIVMSG $chan :[join $output]"
}

# Pioche alatoirement un fragment de phrase du type demand
proc IRCSTORY::random_fragment {num} {
	set type "IRCSTORY::type[subst $num]_fragment"
	return [lindex [subst $$type] [rand [llength [subst $$type]]]]
}

# Contrle du flood
proc IRCSTORY::antiflood {chan type} {
  variable antiflood_msg
  if {![info exists antiflood_msg($chan$type)]} { set antiflood_msg($chan$type) 0 }
  variable instance
  if {![info exists instance($chan$type)]} { set instance($chan$type) 0 }
  set max_instances [lindex [split $IRCSTORY::floodsettings($type) ":"] 0]
  set instance_length [lindex [split $IRCSTORY::floodsettings($type) ":"] 1]
  if { $instance($chan$type) >= $max_instances } {
    if { $antiflood_msg($chan$type) == 0 } {
      set antiflood_msg($chan$type) 1
      if {$type != "global"} {
        putquick "privmsg $chan :[code 04 $chan]:::[code 14 $chan] Contrle de flood activ pour la commande [code bold $chan]!$type[code bold $chan] : pas plus de $max_instances requte(s) toutes les $instance_length secondes.[code endcolor $chan]"
      } else {
        putquick "privmsg $chan :[code 04 $chan]:::[code 14 $chan] Contrle de flood sur les commandes de [code bold $chan]IRC Story[code bold $chan] : pas plus de $max_instances commandes toutes les $instance_length secondes.[code endcolor $chan]"
      }
      utimer $IRCSTORY::antiflood_msg_interval "IRCSTORY::antiflood_msg_reset $chan $type"
    }
    return "flood"
  } else {
    incr instance($chan$type)
    utimer $instance_length "IRCSTORY::antiflood_close_instance $chan $type"
    return "no flood"
  }
}
proc IRCSTORY::antiflood_close_instance {chan type} {
  variable instance
  if { ([info exists instance($chan$type)]) && ($instance($chan$type) > 0) } { incr instance($chan$type) -1 }
}
proc IRCSTORY::antiflood_msg_reset {chan type} {
  variable antiflood_msg
  set antiflood_msg($chan$type) 0
}

# mlange alatoire des lments d'une liste
proc IRCSTORY::randomize_list {data} {
	set list_length [llength $data]
	for { set counter 1 } { $counter <= $list_length } { incr counter } {
		set index [rand [expr $list_length - $counter + 1]]
		lappend randomized_list [lindex $data $index]
		set data [lreplace $data $index $index]
	}
return $randomized_list
}

# filtrage des codes de couleur/gras/soulign si le mode +c est dtect sur le chan
proc IRCSTORY::code {code chan} {
  if {$code == "bold"} {
    if {![string match *c* [lindex [split [getchanmode $chan]] 0]]} { return "\002" } { return "" }
  } elseif {$code == "underline"} {
    if {![string match *c* [lindex [split [getchanmode $chan]] 0]]} { return "\037" } { return "" }
  } elseif {$code == "endcolor"} {
    if {![string match *c* [lindex [split [getchanmode $chan]] 0]]} { return "\003" } { return "" }
  } else {
    if {![string match *c* [lindex [split [getchanmode $chan]] 0]]} { return "\003$code" } { return "" }
  }
}

# filtrage des caractres susceptibles de choquer l'interprteur Tcl
proc IRCSTORY::filter {data} { return [regsub -all {["\]\[\}\{\\]} $data "\\\\&"] }


putlog "\002*$IRCSTORY::scriptname v$IRCSTORY::version*\002 par MenzAgitat a t charg."
